org.apache.hc.core5.reactive

## Class ReactiveResponseConsumer

- java.lang.Object
- - org.apache.hc.core5.reactive.ReactiveResponseConsumer

- All Implemented Interfaces:
    AsyncDataConsumer, AsyncResponseConsumer<Void>, ResourceHolder

      @Contract(threading=SAFE)
      public final class ReactiveResponseConsumer
      extends Object
      implements AsyncResponseConsumer<Void>

  An `AsyncResponseConsumer` that publishes the response body through a `Publisher`, as defined by the Reactive Streams specification. The response is represented as a `Message` consisting of a `HttpResponse` representing the headers and a `Publisher` representing the response body as an asynchronous stream of `ByteBuffer` instances.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReactiveResponseConsumer()` Creates a `ReactiveResponseConsumer`.
    `ReactiveResponseConsumer(FutureCallback<Message<HttpResponse,org.reactivestreams.Publisher<ByteBuffer>>> responseCallback)` Creates a `ReactiveResponseConsumer` that will call back the supplied `FutureCallback` with a streamable response.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `void` | `consumeResponse(HttpResponse response, EntityDetails entityDetails, HttpContext httpContext, FutureCallback<Void> resultCallback)` Triggered to signal receipt of a response message head.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `EntityDetails` | `getEntityDetails()` Returns the response entity details.
    `HttpResponse` | `getInformationResponse()` Returns the intermediate (1xx) HTTP response if one was received.
    `Future<Message<HttpResponse,org.reactivestreams.Publisher<ByteBuffer>>>` | `getResponseFuture()`
    `List<Header>` | `getTrailers()` Returns the trailers received at the end of the response.
    `void` | `informationResponse(HttpResponse response, HttpContext httpContext)` Triggered to signal receipt of an intermediate (1xx) HTTP response.
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ReactiveResponseConsumer

          public ReactiveResponseConsumer()

      Creates a `ReactiveResponseConsumer`.

    - #### ReactiveResponseConsumer

          public ReactiveResponseConsumer(FutureCallback<Message<HttpResponse,org.reactivestreams.Publisher<ByteBuffer>>> responseCallback)

      Creates a `ReactiveResponseConsumer` that will call back the supplied `FutureCallback` with a streamable response.
      Parameters:
        `responseCallback` - the callback to invoke when the response is available for consumption.

  - ### Method Detail

    - #### getResponseFuture

          public Future<Message<HttpResponse,org.reactivestreams.Publisher<ByteBuffer>>> getResponseFuture()

    - #### getInformationResponse

          public HttpResponse getInformationResponse()

      Returns the intermediate (1xx) HTTP response if one was received.
      Returns:
        the information response, or `null` if none.

    - #### getEntityDetails

          public EntityDetails getEntityDetails()

      Returns the response entity details.
      Returns:
        the entity details, or `null` if none.

    - #### getTrailers

          public List<Header> getTrailers()

      Returns the trailers received at the end of the response.
      Returns:
        a non-null list of zero or more trailers.

    - #### consumeResponse

          public void consumeResponse(HttpResponse response,
                                      EntityDetails entityDetails,
                                      HttpContext httpContext,
                                      FutureCallback<Void> resultCallback)

      Description copied from interface: `AsyncResponseConsumer`
      Triggered to signal receipt of a response message head.
      Specified by:
        `consumeResponse` in interface `AsyncResponseConsumer<Void>`
      Parameters:
        `response` - the response message head.
        `entityDetails` - the response entity details or `null` if the response does not enclose an entity.
        `httpContext` - the actual execution context.
        `resultCallback` - the result callback called when response processing has been completed successfully or unsuccessfully.

    - #### informationResponse

          public void informationResponse(HttpResponse response,
                                          HttpContext httpContext)

      Description copied from interface: `AsyncResponseConsumer`
      Triggered to signal receipt of an intermediate (1xx) HTTP response.
      Specified by:
        `informationResponse` in interface `AsyncResponseConsumer<Void>`
      Parameters:
        `response` - the intermediate (1xx) HTTP response.
        `httpContext` - the actual execution context.

    - #### failed

          public void failed(Exception cause)

      Description copied from interface: `AsyncResponseConsumer`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncResponseConsumer<Void>`
      Parameters:
        `cause` - the cause of the failure.

    - #### updateCapacity

          public void updateCapacity(CapacityChannel capacityChannel)
                              throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException` - in case of an I/O error.

    - #### consume

          public void consume(ByteBuffer src)
                       throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException` - in case of an I/O error.

    - #### streamEnd

          public void streamEnd(List<? extends Header> trailers)

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.